﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore

	Private Button2 As B4XView
	Private saveChange As B4XView

	Private ImageView1 As B4XView

	Public commonLabel As B4XView
	Private scienceLabel As B4XView
	Private wiringLabel As B4XView
	Private canopyLabel As B4XView
	Private fertLabel As B4XView
	Private repottingLabel As B4XView
	Private rootLabel As B4XView
	Private sprayLabel As B4XView

	Private operation As Int
	Private datewiredButton As B4XView
	Private datepotButton As B4XView
	Private datefertButton As B4XView
	Private datesprayButton As B4XView
	Private datecanopyButton As B4XView
	Private daterootButton As B4XView
	Private recordLabel As B4XView
	
'	Private stylesCustomListView1 As CustomListView
	Private lstData As List
	Dim newindex As Int
	
''''	Dim nowYear, nowMonth, nowDay As Int
	Private style1, style2, style3 As String
	Private save As Button
		
	Private Label8 As Label
	Private acceptDate As B4XView
	
	Private Panel2 As B4XView
	Private daySpinner As Spinner
	Private monthSpinner As Spinner
	Private yearSpinner As Spinner
	Private soilB4XRadioButton1 As B4XRadioButton
	Private soilB4XRadioButton2 As B4XRadioButton
	Private soilB4XRadioButton3 As B4XRadioButton
	Private soilB4XRadioButton4 As B4XRadioButton
	Private soilB4XRadioButton5 As B4XRadioButton
	Private soilB4XRadioButton6 As B4XRadioButton
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	lstData = File.ReadList(File.DirAssets, "styles.csv")
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	
	B4XPages.SetTitle (Me, "MANAGE card record")
	
	Root.LoadLayout("manage")
	
	For Each Text As String In lstData
		Text = Text.Replace(",", "-")
'		stylesCustomListView1.AddTextItem(Text, Text)
	Next

'	nowYear  = DateTime.GetYear(DateTime.Now)
'	nowMonth = DateTime.GetMonth(DateTime.Now)
'	nowDay   = DateTime.GetDayOfMonth(DateTime.Now)

	Panel2.Visible = False
	Dim MinYear As Int
	Dim MaxYear As Int
	Dim i As Int
	Dim d As Long

	' Initialize Year spinner
	MinYear = 2000
	MaxYear = 2040
	For i = MinYear To MaxYear
		yearSpinner.Add(i)
	Next
	' Initialize Month spinner
	For i = 1 To 12
		DateTime.DateFormat = "d/M/yyyy"
		d = DateTime.DateParse("1/" & i & "/2016")
		DateTime.DateFormat = "MMM"
		monthSpinner.Add(DateTime.Date(d))
	Next
	' Initialize Day spinner
	For i = 1 To 31
		If i < 10 Then
			daySpinner.Add("0" & i)
		Else
			daySpinner.Add(i)
		End If
	Next
	
	SetCurrentDate
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem

    commonLabel.Text = "XXX"
End Sub

Sub B4xPage_Appear
	' when the page appears get the tree for which the index or name was sent
	' from the VIEW page.  There probably shouldn't be a menu option for MANAGE
	' on the landing page
	
'	stylesCustomListView1.JumpToItem (newindex)
End Sub

Private Sub saveChange_Click
'	Private query As String
	Private soilmix As String
	
	xui.MsgboxAsync(" SAVE this card Record", "Manage the work record for your cards")
	
	Dim i As Int
	soilmix = 0
	For i = 0 To 5
		If (soilB4XRadioButton1.Checked = True) Then 
			soilmix = i 
		End If
		If (soilB4XRadioButton2.Checked = True) Then 
			soilmix = i
 		End If
		If (soilB4XRadioButton3.Checked = True) Then
			 soilmix = i	
		End If
		If (soilB4XRadioButton4.Checked = True) Then 
			soilmix = i
		End If
		If (soilB4XRadioButton5.Checked = True) Then 
			soilmix = i
		End If
		If (soilB4XRadioButton6.Checked = True) Then 
			soilmix = i
		End If
	Next

'	query = "UPDATE Cards SET CommName = '" & commonLabel.Text & "' SciName = '" & scienceLabel.Text  & "' wiring = '" & datewiredButton.Text & "' potting = '" & datepotButton.Text & "' fert = '" & datefertButton.Text & "' spray = '" & datesprayButton.Text & "' rootprune = '" & daterootButton.Text & "' canopyprune = '" & datecanopyButton.Text & "' soilmix = '" & soilmix & "' WHERE RecNum = " & recordLabel.Text
''''	Log (query)	

'''' TO DO :  INSERT THE CODE TO WRITE IT TO THE DATABASE

End Sub
'
Private Sub Button2_Click
	B4XPages.ShowPage("MainPage")
End Sub

' *****  CARD ONE
Private Sub datewiredButton_Click
	operation = 0
	datewiredButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CARD TWO
Private Sub datepotButton_Click
	operation = 1
	datepotButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CARD THREE
Private Sub datefertButton_Click
	operation = 2
	datefertButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CARD FOUR
Private Sub datesprayButton_Click
	operation = 3
	datesprayButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CARD FIVE
Private Sub datecanopyButton_Click
	operation = 4
	datecanopyButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CARD SIX
Private Sub daterootButton_Click
	operation = 5
	daterootButton.Visible = False
	Panel2.Visible = True
End Sub

Private Sub stylesCustomListView1_ItemClick (Index As Int, Value As Object)
	Dim components() As String
	
	components = Regex.Split("-", Value) 'the pipe needs to be escaped as it has special meaning in Regex.
	style1 = components(0)
	style2 = components(1)
	style3 = components(2)
	
	xui.MsgboxAsync(Index & " " & style1 & " " & style2 & " " & style3, "Chosen Style components")
End Sub

Private Sub stylesCustomListView1_ReachEnd
'	stylesCustomListView1.JumpToItem (0)
	
End Sub

Private Sub daySpinner_ItemClick (Position As Int, Value As Object)
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Private Sub monthSpinner_ItemClick (Position As Int, Value As Object)
	PopulateDD
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Private Sub yearSpinner_ItemClick (Position As Int, Value As Object)
	PopulateDD
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Sub SetCurrentDate()
	yearSpinner.SelectedIndex = yearSpinner.IndexOf(DateTime.GetYear(DateTime.Now))
	monthSpinner.SelectedIndex = DateTime.GetMonth(DateTime.Now) - 1
	daySpinner.SelectedIndex = DateTime.GetDayOfMonth(DateTime.Now) - 1
End Sub

Sub PopulateDD
	Select (monthSpinner.SelectedIndex + 1)
		Case 1, 3, 5, 7, 8, 10, 12
			If daySpinner.Size = 28 Then
				daySpinner.Add("29")
			End If
			If daySpinner.Size = 29 Then
				daySpinner.Add("30")
			End If
			If daySpinner.Size = 30 Then
				daySpinner.Add("31")
			End If
		Case 4, 6, 9, 11
			If daySpinner.Size = 28 Then
				daySpinner.Add("29")
			End If
			If daySpinner.Size = 29 Then
				daySpinner.Add("30")
			End If
			If daySpinner.Size = 31 Then
				daySpinner.RemoveAt(30)
			End If
		Case Else ' 2
			If LeapYear(yearSpinner.SelectedItem) Then ' Leap Year
				If daySpinner.Size = 31 Then
					daySpinner.RemoveAt(30)
				End If
				If daySpinner.Size = 30 Then
					daySpinner.RemoveAt(29)
				End If
				If daySpinner.Size = 28 Then
					daySpinner.Add("29")
				End If
			Else
				If daySpinner.Size = 31 Then
					daySpinner.RemoveAt(30)
				End If
				If daySpinner.Size = 30 Then
					daySpinner.RemoveAt(29)
				End If
				If daySpinner.Size = 29 Then
					daySpinner.RemoveAt(28)
				End If
			End If
	End Select
End Sub

Sub LeapYear(Year As Int) As Boolean
	If Year Mod 400 = 0 Then Return True
	If Year Mod 100 = 0 Then Return False
	If Year Mod 4 = 0 Then Return True
	Return False
End Sub

Private Sub acceptDate_Click
	Select operation
		Case  0
			datewiredButton.Text = acceptDate.text
			datewiredButton.Visible = True
		Case  1
			datepotButton.Text = acceptDate.text
			datepotButton.Visible = True
		Case  2
			datefertButton.Text = acceptDate.text
			datefertButton.Visible = True
		Case  3
			datesprayButton.Text = acceptDate.text
			datesprayButton.Visible = True
		Case  4
			datecanopyButton.Text = acceptDate.text
			datecanopyButton.Visible = True
		Case  5
			daterootButton.Text = acceptDate.text
			daterootButton.Visible = True
		Case Else
	
	End Select
	
	Panel2.Visible = False
End Sub

' Method
Public Sub NewValue(Value As String)
'	Log (Value)
	
	Dim components2() As String
	components2 = Regex.Split(",", Value) 'the pipe needs to be escaped as it has special meaning in Regex.

	recordLabel.Text = components2(0)	'0
	commonLabel.Text = components2(1)	'1
	scienceLabel.Text = components2(2)	'2 sciname

	For Each Text As String In lstData
		Text = Text.Replace(",", "-")
'		stylesCustomListView1.AddTextItem(Text, Text)
	Next

	newindex = components2(11)
''''	Log ("Manage NewVaLUE = " & components2(11))

	datewiredButton.Text  = components2(12) ' 12 wiring
	datepotButton.Text	  =components2(13) ' 13 repot
	datefertButton.Text	  = components2(14) ' 14 fert
	datesprayButton.Text  = components2(15) ' 15 spray
	datecanopyButton.Text = components2(16) ' 16 root
	daterootButton.Text	  = components2(17) ' 17 canopy
	
	''' HAVE TO SET THE INDEX OF THE STYLE SCROLLER TO THE VALUE OF TREE UNDER MANAGEMENT
	
		Select (components2(18))
			Case " High Draining " '0
						soilB4XRadioButton1.Checked = True
			Case " Low Draining " '1
						soilB4XRadioButton2.Checked = True
			Case " General utility " '2
						soilB4XRadioButton3.Checked = True
			Case " Deciduous mix " '3
						soilB4XRadioButton4.Checked = True
			Case " Evergreen mix " '4
						soilB4XRadioButton5.Checked = True
			Case " Conifer mix " '5
						soilB4XRadioButton6.Checked = True
			Case Else
						soilB4XRadioButton1.Checked = True
	End Select

End Sub

 