﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	
	Private SQL2 As SQL
	Private Cursor1 As Cursor
	
	Private xui As XUI 'ignore
	
	Private cardAS_CardSlider1 As AS_CardSlider

	Private Button2 As B4XView

	Private nextcardLabel As B4XView
	Private previouscardLabel As B4XView
	
	Private common As B4XView  ' this is hidden but has to set to send it to manage

	Private Label3 As B4XView
	Private Label4 As B4XView
	Private Label5 As B4XView
	Private Label5a As B4XView
	Private Label5b As B4XView
	Private Label7 As B4XView
	Private Label7a As B4XView
	Private Label8 As B4XView
	Private Label8a As B4XView
	Private Label9 As B4XView
	Private Label9a As B4XView
	Private Label10 As B4XView
	Private Label10a As B4XView
	Private Label11 As B4XView
	Private Label11a As B4XView
	Private Label12 As B4XView
	Private Label12a As B4XView
	Private Label13 As B4XView  ' record number
	
	Private acquired As B4XView
	Private colltype As B4XView
	Private indig As B4XView
	Private decidu As B4XView
	Private conifer As B4XView
	Private price As B4XView
	Private location As B4XView
	Private age As B4XView
	Private style As B4XView
	
	Private lstData As List
	Dim indexnew As Int
	Private lstStyles As List
	Private lstDetail As String 'List

	Private managecard As Button
	
	Private totalRecs As Label
	
	'''' Public Value As String 'cause an error
	Public lastcard, manageflag As Int 
	
	Dim sizeis As Int
	Private Panel4 As B4XView
	Private Button1 As Button
	Private manageButton1 As Button
	
	' panel4 text
	Private commonLabel As B4XView
	Private scienceLabel As B4XView
	Private recordLabel As B4XView
	
	Private datewiredButton As B4XView
	Private datepotButton As B4XView
	Private datefertButton As B4XView
	Private datesprayButton As B4XView
	Private datecanopyButton As B4XView
	Private daterootButton As B4XView
	Private soilB4XRadioButton1 As B4XRadioButton
	Private soilB4XRadioButton2 As B4XRadioButton
	Private soilB4XRadioButton3 As B4XRadioButton
	Private soilB4XRadioButton4 As B4XRadioButton
	Private soilB4XRadioButton5 As B4XRadioButton
	Private soilB4XRadioButton6 As B4XRadioButton
	
	Private stylesCustomListView1 As CustomListView
	Private style1, style2, style3 As String
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	' change the styles.csv to read the list of trees which is what the layout will expect
	' read Cards list from database
	
	lstStyles = File.ReadList(File.DirAssets, "styles.csv")
    
	lstData.Initialize
	
	lastcard   = 0 'cardsAS_CardSlider1.Index
	manageflag = 0
	 
	LoadCards
	
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root

	Root.LoadLayout("view")
	B4XPages.SetTitle (Me, "VIEW Card records")
	
	cardAS_CardSlider1.LazyLoading = False
	
	For Each Text As String In lstStyles
		Text = Text.Replace(",", "*")
''''		Log ("TEXT -> " & Text)
		stylesCustomListView1.AddTextItem(Text, Text)
	Next

''''	Dim i = 0 As Int
	readDetail (lstData.Get(cardAS_CardSlider1.Index))

End Sub

Sub B4XPage_Appear
		stylesCustomListView1.JumpToItem (indexnew)
	
	Dim i = 0 As Int

	cardAS_CardSlider1.Clear
	cardAS_CardSlider1.CornerRadius = 20

	LoadCards
	
	totalRecs.Text = sizeis
'	readDetail (lstData.Get(cardAS_CardSlider1.Index))

   If (lastcard < 0) Then
	   	cardAS_CardSlider1.Index = 0
		lastcard = lastcard + 1
	Else
		cardAS_CardSlider1.Index = lastcard
	End If
   
'''	Log ("last card   = " & lastcard)
''''	Log ("card index  = " & cardAS_CardSlider1.Index)

'' I realised this line is redundant/wrong	cardAS_CardSlider1_PageChanged(cardAS_CardSlider1.Index, lastcard)
	
	For Each Text As String In lstData
		Dim xpnl As B4XView = xui.CreatePanel("")
		xpnl.SetLayoutAnimated(0,0,0,cardAS_CardSlider1.ItemWidth,cardAS_CardSlider1.mBase.Height)
		'xpnl.Color = xui.Color_ARGB(255,Rnd(0,256),Rnd(0,256),Rnd(0,256))
		xpnl.LoadLayout("detailLabel")

		Dim components2() As String
			components2 = Regex.Split(",", lstDetail)

			Label13.Text  = components2 (0)
			common.Text   = components2(1)  ' used to send value to manage
			Label3.Text   = components2(2)

			acquired.Text = components2(3)	' date acquired
			colltype.Text = components2(4)	' source of the tree
			indig.Text    = components2(5)	' indiginous/exotic
			decidu.Text   = components2(6)	' deciduous/evergreen
			conifer.Text  = components2(7)	' broadleaf/conifer
			price.Text    = components2(8)	' purchase price
			location.Text = components2(9)	' location at which collected
			age.Text      = components2(10)	' approx/actual age
			style.Text    = components2(11)	'  style in use
			Label7a.Text  = components2(12)	' wiring
			Label8a.Text  = components2(13)	' repot
			Label9a.Text  = components2(14)	' fert
			Label10a.Text = components2(15)	' spray
			Label12a.Text = components2(16)	' root
			Label11a.Text = components2(17)	' canopy
			
		Dim soiltext As String
		
		Select components2(18)  ' This is just here to test if it happens whereever one stops; 
								' it does for me.... see Line 233 below.
			Case 0
				soiltext = " High Draining "
			Case 1
				soiltext = " Low Draining "
			Case 2
				soiltext = " General utility "
			Case 3
				soiltext = " Deciduous mix "
			Case 4
				soiltext = "Evergreen mix "
			Case 5
				soiltext = " Conifer mix "
		End Select
		
		Label4.Text =  soiltext 'components2(18)	

		Dim parseStyle As String
			parseStyle = lstStyles.Get(components2(11))

		Dim components3() As String
			components3 = Regex.Split(",", parseStyle)
				
			Label5.Text = components3(0)
			Label5a.Text = components3(1)
			Label5b.Text = components3(2)
		
		Dim xlbl_Text As B4XView = xpnl.GetView(0)
	 		xlbl_Text.Text = Text
		
			cardAS_CardSlider1.AddPage(xpnl,i)
		
			i = i + 1
		
''''Log ("slider size 2 " & cardAS_CardSlider1.Size)
	Next

''''Log ("list size 2 " & lstData.Size)
End Sub

Private Sub Button1_Click
	xui.MsgboxAsync("VIEW Card Records", "VIEW all card records")
End Sub

Private Sub Button2_Click
	B4XPages.ShowPage("MainPage")
End Sub

Private Sub cardAS_CardSlider1_PageChanged(OldIndex As Int, NewIndex As Int)

''''
Log ("PageChanged : old index " & OldIndex & " new  index " & NewIndex)

	Label13.Text = NewIndex + 1  ' it stops here, (route to here is : View from main page
								 '	then try to navigate item to item the View page with navigation arrows
								 '  or slider swipe on item name panel)
								 '  As in the posted message thread :
								 '  if you're looking at the log/code to figure out
								 '  something it will just drop back to the Bridge after some seconds
								 '  the Toast message appears on the phone while it is stopped
								 '  on the breakpoint.....

''''''Log ("slider size " & cardAS_CardSlider1.Size)

	readDetail (lstData.Get(cardAS_CardSlider1.Index))
''''	Log ("card " & cardAS_CardSlider1.Index)
	
	Dim components2() As String
	components2 = Regex.Split(",", lstDetail) 'the pipe needs to be escaped as it has special meaning in Regex.

	'''common.Text = components2(1)	'1 
	commonLabel.Text = components2(1)	'1
	'''Label3.Text      = components2(2)	'2
	scienceLabel.Text = components2(2)
	recordLabel.Text = Label13.text

	Dim parseStyle As String
	parseStyle = lstStyles.Get(components2(11))

	Dim components3() As String
	components3 = Regex.Split(",", parseStyle)
				
	Label5.Text		= components3(0) 
	Label5a.Text	= components3(1) 
	Label5b.Text	= components3(2) 

	acquired.Text	= components2(3)
	colltype.Text	= components2(4)
	indig.Text		= components2(5)
	decidu.Text		= components2(6)
	conifer.Text	= components2(7)
	price.Text		= components2(8)
	location.Text	= components2(9)
	age.Text		= components2(10)
	style.Text		= components2(11)
	Label7a.Text	= components2(12)
		datewiredButton.Text  = Label7a.Text	' wired 
		datepotButton.text    = Label8a.Text	' repot
		datefertButton.text   = Label9a.Text	' fert
		datesprayButton.text  = Label10a.Text	' spray
		daterootButton.text   = Label12a.Text	' root
		datecanopyButton.Text = Label11a.Text	' canopy
	
	Dim soiltext As String
	soiltext = ""
	
	Select (components2(18))
		Case 0 '" High Draining " '0
			soilB4XRadioButton1.Checked = True
			soiltext = " High Draining "
		Case 1 '" Low Draining " '1
			soilB4XRadioButton2.Checked = True
			soiltext = " Low Draining "
		Case 2 '" General utility " '2
			soilB4XRadioButton3.Checked = True
			soiltext = " General utility "
		Case 3 '" Deciduous mix " '3
			soilB4XRadioButton4.Checked = True
			soiltext = " Deciduous mix "
		Case 4 '" Evergreen mix " '4
			soilB4XRadioButton5.Checked = True
			soiltext = " Evergreen mix "
		Case 5 '" conifer mix " '5
			soilB4XRadioButton6.Checked = True
			soiltext = " Conifer mix "
		Case Else
			soilB4XRadioButton1.Checked = True
			soiltext = " High Draining "
	End Select

	Label4.Text = soiltext	' 18 soil type
End Sub

Private Sub previouscardLabel_Click
	cardAS_CardSlider1.PreviousPage
End Sub

Private Sub nextcardLabel_Click
	cardAS_CardSlider1.NextPage
End Sub

Private Sub detailLabel_Click

End Sub

Sub LoadCards
	SQL2.Initialize(File.DirDefaultExternal, "cards.db", False)    'DirRootExternal
	Dim rs As ResultSet = SQL2.ExecQuery("SELECT CommName FROM Cards ")

	sizeis = rs.RowCount
	Log ("LoadCards : size is  = " & sizeis)
	lstData.Clear

	Do While rs.NextRow
		Dim element As String
		element = rs.GetString("Cards.CommName")

''''Log ("LoadCards : element " & element)
'	Log (row(0) & " -> " & row(1) & " -> " & row(2) & " -> " & row(3) & " -> " & row(4))

		lstData.Add(element)
	Loop
	rs.Close
End Sub

Sub readDetail (cardkey As String)
	Dim Query = "SELECT * FROM Cards WHERE CommName = '" & cardkey &"'" As String
	
	Cursor1 = Starter.SQL1.ExecQuery(Query)
	Cursor1.Position = 0

	lstDetail = Cursor1.GetString2(0) & "," & Cursor1.GetString2(1) & "," & Cursor1.GetString2(2) & "," & Cursor1.GetString2(3)	 & "," & Cursor1.GetString2(4) & "," & Cursor1.GetString2(5) & "," & Cursor1.GetString2(6)	& "," & Cursor1.GetString2(7)	& "," & Cursor1.GetString2(8)	& "," & Cursor1.GetString2(9)	& "," & Cursor1.GetString2(10)	& "," & Cursor1.GetString2(11)	& "," & Cursor1.GetString2(12)	& "," & Cursor1.GetString2(13)	& "," & Cursor1.GetString2(14)	& "," & Cursor1.GetString2(15)	& "," & Cursor1.GetString2(16)	& "," & Cursor1.GetString2(17)	& "," & Cursor1.GetString2(18)

' Log (lstDetail)

End Sub

Private Sub managecard_Click
	' 3 - Calls B4XMainPage's method
	Panel4.Visible     = True
	Button2.Visible    = False
	managecard.Visible = False
	
	Dim tempSTR As StringBuilder

	manageflag = 1
	
	lastcard = cardAS_CardSlider1.Index
	Log ("Manage Card -> last card " & lastcard & " Manage flag > " & manageflag)
  
	tempSTR.Initialize
  
	tempSTR.Append(Label13.Text).Append(",").Append(common.Text).Append(",").Append(Label3.Text).Append(",").Append(acquired.Text).Append(",").Append(colltype.Text).Append(",").Append(indig.Text).Append(",").Append(decidu.Text).Append(",").Append(conifer.Text).Append(",").Append(price.Text).Append(",").Append(location.Text).Append(",").Append(age.Text).Append(",").Append(style.Text).Append(",").Append(Label7a.Text).Append(",").Append(Label8a.Text).Append(",").Append(Label9a.Text).Append(",").Append(Label10a.Text).Append(",").Append(Label12a.Text).Append(",").Append(Label11a.Text).Append(",").Append(Label4.Text)

''''	Log (tempSTR)

'	B4XPages.MainPage.newa.NewValue(tempSTR)
	
'	B4XPages.ShowPage("manage") ' manageButton
End Sub

Private Sub manageButton1_Click
	Panel4.Visible     = False
	Button2.Visible    = True
	managecard.Visible = True
End Sub

Private Sub stylesCustomListView1_ItemClick (Index As Int, Value As Object)
	Dim components() As String
	
Log (Value)	
	components = Regex.Split(",", Value) 'the pipe needs to be escaped as it has special meaning in Regex.
	style1 = components(0)
'	style2 = components(1)
'	style3 = components(2)
'	
'	
	Log ("STYLE -> " & style1 & " " & style2 & " " & style3)
'	
	xui.MsgboxAsync(Index & " " & style1 & " " & style2 & " " & style3, "Chosen Style components")
End Sub

Private Sub stylesCustomListView1_ReachEnd
	stylesCustomListView1.JumpToItem (0)
	
End Sub